<?php // $Id: wghtml_node_module.php,v 1.1.4.1 2007/02/25 02:46:54 djnz Exp $

/**
 * Implementation of hook_help
 */
function wghtml_help($section) {
  switch ($section) {
    case 'admin/help#wghtml':
      // This description is shown in the listing at admin/modules.
      return t('Import HTML pages to nodes.');
    case 'node/add#wghtml':
      // This description shows up when users click "create content."
      return t('wgHTML content is created automagically. The results of manually creating a wgHTML node are unpredicatable - don\'t do it.');
  }
}

/**
 * Implementation of hook_node_info
 */
function wghtml_node_info() {
  return array(
    'wghtml' => array(
      'name' => t('Imported HTML page'),
      'module' => 'wghtml',
      'description' => t('wgHTML content is created automagically. The results of manually creating a wgHTML node are unpredicatable - don\'t do it.'),
    )
  );
}

/**
 * Implementation of hook_perm
 */
function wghtml_perm() {
  return array('edit wgHTML nodes');
}

/**
 * Implementation of hook_access
 */
function wghtml_access($op, $node) {

  if ( $op == 'create' ) {
    return FALSE; // wgHTML nodes are created automagically
  }

  if ($op == 'update' || $op == 'delete') {
     return user_access('edit wgHTML nodes');
  }
}

/**
 * Implementation of hook_load().
 */
function wghtml_load(&$node) {
  $page =& _wghtml_get_object();

  // see if the page needs loading
  if ( empty($page->pageId) || $page->pageId!==$node->nid ) {
    $page->get_page_from_id($node->nid);
  }
  $node->wghtml = $page;
}

/**
 * Implementation of hook_view
 */
function wghtml_view(&$node, $teaser = 0, $page = 0) {
  $node = node_prepare($node, $teaser);
  if ( !empty($node->wghtml) ) {
    $node->content['wghtml_before'] = array(
      '#value'  => theme('wghtml_view_before', $node),
      '#weight' => -1,
      );
    $node->content['wghtml_after'] = array(
      '#value'  => theme('wghtml_view_after', $node),
      '#weight' => 1,
      );
  }
  return $node;
}

/**
 * Theme functions.
 */
function theme_wghtml_view_before($node) {
}

function theme_wghtml_view_after($node) {
  return "\n<div style=\"text-align: right; font-size: 80%; \">".$node->wghtml->status."</div>\n";
}

/**
 * Action hook for show action
 */
function _wghtml_show($action=false, $file=false) {

  // get the wgHTML object which does all the work
  $page =& _wghtml_get_object();
  // get the requested page: $file is usually false so get_page uses the REQUEST_URI from the redirect as a default
  $page->get_page($file);

  // now load the node: the node load hook will add the page to the node
  $node = module_invoke('node', 'load', $page->pageId);
  return node_page_view($node);

  if ( empty($page->error) ) {
    drupal_set_title($page->title);
    $output = $page->body;
    $output .= '<div style="font-size: 80%; border: solid black; border-width: 1px 0 0; text-align: right;">'.$page->status.'</div>';
  } else {
    $output  = '<div style="background: red; color: white; padding: 2px 4px;">Error: ';
    $output .= $page->error.'</div>';
  }
  if (true) {
    $output .= '<br /><br /><br />Dump of $page and $node for debug:<pre>';
    ob_start();
    print_r($page);
    print_r($node);
  	$output .= htmlspecialchars(ob_get_clean()) . '</pre>';
  }
  echo theme('page', $output);
}

